window.Gleam.initSearch([{"doc":"gild","title":"gild","content":"# gild\n\nwork in progress\n\nextremely alpha\n\nfeedback welcome!\n\nexample usage:\n```import gild/cluster\nimport gild/os/debian\nimport gild/types.{type VM}\nimport gild/vm\n\npub fn project(members: List(VM)) -&gt; String {\n  cluster.new()\n  |&gt; cluster.name(&quot;my sweet project&quot;)\n  |&gt; cluster.export()\n}\n\npub fn home() -&gt; VM {\n  vm.new()\n  |&gt; vm.name(&quot;home&quot;)\n  |&gt; vm.os(debian.version(&quot;12&quot;))\n  |&gt; vm.update()\n  |&gt; vm.install(&quot;mysql_server&quot;)\n  |&gt; vm.return()\n}\n\npub fn work() -&gt; VM {\n  vm.new()\n  |&gt; vm.name(&quot;work&quot;)\n  |&gt; vm.os(debian.version(&quot;12&quot;))\n  |&gt; vm.update()\n  |&gt; vm.install(&quot;apache2&quot;)\n  |&gt; vm.install(&quot;mysql_server php&quot;)\n  |&gt; vm.return()\n}\n\npub fn main() {\n  let c =\n    cluster.new()\n    |&gt; cluster.name(&quot;from africa with love&quot;)\n    |&gt; cluster.member(home())\n    |&gt; cluster.member(work())\n    |&gt; cluster.export()\n  //io.debug(c)\n}\n```\n\noutput:\n![sample json output](sample_json_output.png)\n\nthis library is used to help create visualizations inside the [linkha.sh](http://linkha.sh) online playground and will be used inside a cli utility to make the declarative configuration come to life\n","url":"index.html"},{"doc":"gild","title":"gild","content":"","url":"gild.html"},{"doc":"gild/types","title":"Cluster","content":"pub type Cluster =\n  List(VM)\n\n\nSynonyms:\ngild/types.Cluster\ngild/types Cluster","url":"gild/types.html#Cluster"},{"doc":"gild/types","title":"Config","content":"pub type Config =\n  List(KV)\n\n\nSynonyms:\ngild/types.Config\ngild/types Config","url":"gild/types.html#Config"},{"doc":"gild/types","title":"KV","content":"pub type KV =\n  #(String, String)\n\n\nSynonyms:\ngild/types.KV\ngild/types KV","url":"gild/types.html#KV"},{"doc":"gild/types","title":"VM","content":"pub type VM =\n  #(String, Config)\n\n\nSynonyms:\ngild/types.VM\ngild/types VM","url":"gild/types.html#VM"},{"doc":"gild/types","title":"gild/types","content":"","url":"gild/types.html"},{"doc":"gild/cluster","title":"export","content":"pub fn export(\n  config: List(#(String, List(#(String, String)))),\n) -&gt; String\n\nSynonyms:\ngild/cluster.export\ngild/cluster export","url":"gild/cluster.html#export"},{"doc":"gild/cluster","title":"member","content":"pub fn member(\n  config: List(#(String, List(#(String, String)))),\n  member: #(String, List(#(String, String))),\n) -&gt; List(#(String, List(#(String, String))))\n\nSynonyms:\ngild/cluster.member\ngild/cluster member","url":"gild/cluster.html#member"},{"doc":"gild/cluster","title":"name","content":"pub fn name(\n  config: List(#(String, List(#(String, String)))),\n  name: String,\n) -&gt; List(#(String, List(#(String, String))))\n\nSynonyms:\ngild/cluster.name\ngild/cluster name","url":"gild/cluster.html#name"},{"doc":"gild/cluster","title":"new","content":"pub fn new() -&gt; List(#(String, List(#(String, String))))\n\nSynonyms:\ngild/cluster.new\ngild/cluster new","url":"gild/cluster.html#new"},{"doc":"gild/cluster","title":"gild/cluster","content":"","url":"gild/cluster.html"},{"doc":"gild/container","title":"Config","content":"pub type Config =\n  List(KV)\n\n\nSynonyms:\ngild/container.Config\ngild/container Config","url":"gild/container.html#Config"},{"doc":"gild/container","title":"KV","content":"pub type KV =\n  #(String, String)\n\n\nSynonyms:\ngild/container.KV\ngild/container KV","url":"gild/container.html#KV"},{"doc":"gild/container","title":"config","content":"pub fn config() -&gt; List(#(String, String))\n\nSynonyms:\ngild/container.config\ngild/container config","url":"gild/container.html#config"},{"doc":"gild/container","title":"image","content":"pub fn image(\n  config: List(#(String, String)),\n  image: String,\n) -&gt; List(#(String, String))\n\nSynonyms:\ngild/container.image\ngild/container image","url":"gild/container.html#image"},{"doc":"gild/container","title":"name","content":"pub fn name(\n  config: List(#(String, String)),\n  name: String,\n) -&gt; List(#(String, String))\n\nSynonyms:\ngild/container.name\ngild/container name","url":"gild/container.html#name"},{"doc":"gild/container","title":"version","content":"pub fn version(\n  config: List(#(String, String)),\n  version: String,\n) -&gt; List(#(String, String))\n\nSynonyms:\ngild/container.version\ngild/container version","url":"gild/container.html#version"},{"doc":"gild/container","title":"gild/container","content":"","url":"gild/container.html"},{"doc":"gild/helpers","title":"gild/helpers","content":"","url":"gild/helpers.html"},{"doc":"gild/os/debian","title":"version","content":"pub fn version(version: String) -&gt; Result(String, String)\n\nSynonyms:\ngild/os/debian.version\ngild/os/debian version","url":"gild/os/debian.html#version"},{"doc":"gild/os/debian","title":"gild/os/debian","content":"","url":"gild/os/debian.html"},{"doc":"gild/os/ubuntu","title":"OS","content":"pub type OS {\n  Ubuntu(version: String)\n  Debian(version: String)\n  Arch(version: String)\n  CentOS(version: String)\n}\n\nUbuntu(version: String)\n\n\nDebian(version: String)\n\n\nArch(version: String)\n\n\nCentOS(version: String)\n\n\nSynonyms:\ngild/os/ubuntu.OS\ngild/os/ubuntu OS","url":"gild/os/ubuntu.html#OS"},{"doc":"gild/os/ubuntu","title":"version","content":"pub fn version(\n  version: String,\n) -&gt; Result(#(String, String), String)\n\nSynonyms:\ngild/os/ubuntu.version\ngild/os/ubuntu version","url":"gild/os/ubuntu.html#version"},{"doc":"gild/os/ubuntu","title":"gild/os/ubuntu","content":"","url":"gild/os/ubuntu.html"},{"doc":"gild/vm","title":"export","content":"pub fn export(config: List(#(String, String))) -&gt; String\n\nSynonyms:\ngild/vm.export\ngild/vm export","url":"gild/vm.html#export"},{"doc":"gild/vm","title":"install","content":"pub fn install(\n  config: List(#(String, String)),\n  command: String,\n) -&gt; List(#(String, String))\n\nSynonyms:\ngild/vm.install\ngild/vm install","url":"gild/vm.html#install"},{"doc":"gild/vm","title":"name","content":"pub fn name(\n  config: List(#(String, String)),\n  name: String,\n) -&gt; List(#(String, String))\n\nSynonyms:\ngild/vm.name\ngild/vm name","url":"gild/vm.html#name"},{"doc":"gild/vm","title":"new","content":"pub fn new() -&gt; List(#(String, String))\n\nSynonyms:\ngild/vm.new\ngild/vm new","url":"gild/vm.html#new"},{"doc":"gild/vm","title":"os","content":"pub fn os(\n  config: List(#(String, String)),\n  name: Result(String, String),\n) -&gt; List(#(String, String))\n\nSynonyms:\ngild/vm.os\ngild/vm os","url":"gild/vm.html#os"},{"doc":"gild/vm","title":"return","content":"pub fn return(\n  config: List(#(String, String)),\n) -&gt; #(String, List(#(String, String)))\n\nSynonyms:\ngild/vm.return\ngild/vm return","url":"gild/vm.html#return"},{"doc":"gild/vm","title":"update","content":"pub fn update(\n  config: List(#(String, String)),\n) -&gt; List(#(String, String))\n\nSynonyms:\ngild/vm.update\ngild/vm update","url":"gild/vm.html#update"},{"doc":"gild/vm","title":"gild/vm","content":"","url":"gild/vm.html"}]);